// automatically generated by the FlatBuffers compiler, do not modify

package Serialization;

import java.nio.*;
import java.lang.*;
import java.util.*;
import com.google.flatbuffers.*;

@SuppressWarnings("unused")
public final class NodeModel extends Table {
  public static void ValidateVersion() { Constants.FLATBUFFERS_1_12_0(); }
  public static NodeModel getRootAsNodeModel(ByteBuffer _bb) { return getRootAsNodeModel(_bb, new NodeModel()); }
  public static NodeModel getRootAsNodeModel(ByteBuffer _bb, NodeModel obj) { _bb.order(ByteOrder.LITTLE_ENDIAN); return (obj.__assign(_bb.getInt(_bb.position()) + _bb.position(), _bb)); }
  public void __init(int _i, ByteBuffer _bb) { __reset(_i, _bb); }
  public NodeModel __assign(int _i, ByteBuffer _bb) { __init(_i, _bb); return this; }

  public String registrationName() { int o = __offset(4); return o != 0 ? __string(o + bb_pos) : null; }
  public ByteBuffer registrationNameAsByteBuffer() { return __vector_as_bytebuffer(4, 1); }
  public ByteBuffer registrationNameInByteBuffer(ByteBuffer _bb) { return __vector_in_bytebuffer(_bb, 4, 1); }
  public byte type() { int o = __offset(6); return o != 0 ? bb.get(o + bb_pos) : 0; }
  public Serialization.PortModel ports(int j) { return ports(new Serialization.PortModel(), j); }
  public Serialization.PortModel ports(Serialization.PortModel obj, int j) { int o = __offset(8); return o != 0 ? obj.__assign(__indirect(__vector(o) + j * 4), bb) : null; }
  public int portsLength() { int o = __offset(8); return o != 0 ? __vector_len(o) : 0; }
  public Serialization.PortModel.Vector portsVector() { return portsVector(new Serialization.PortModel.Vector()); }
  public Serialization.PortModel.Vector portsVector(Serialization.PortModel.Vector obj) { int o = __offset(8); return o != 0 ? obj.__assign(__vector(o), 4, bb) : null; }

  public static int createNodeModel(FlatBufferBuilder builder,
      int registration_nameOffset,
      byte type,
      int portsOffset) {
    builder.startTable(3);
    NodeModel.addPorts(builder, portsOffset);
    NodeModel.addRegistrationName(builder, registration_nameOffset);
    NodeModel.addType(builder, type);
    return NodeModel.endNodeModel(builder);
  }

  public static void startNodeModel(FlatBufferBuilder builder) { builder.startTable(3); }
  public static void addRegistrationName(FlatBufferBuilder builder, int registrationNameOffset) { builder.addOffset(0, registrationNameOffset, 0); }
  public static void addType(FlatBufferBuilder builder, byte type) { builder.addByte(1, type, 0); }
  public static void addPorts(FlatBufferBuilder builder, int portsOffset) { builder.addOffset(2, portsOffset, 0); }
  public static int createPortsVector(FlatBufferBuilder builder, int[] data) { builder.startVector(4, data.length, 4); for (int i = data.length - 1; i >= 0; i--) builder.addOffset(data[i]); return builder.endVector(); }
  public static void startPortsVector(FlatBufferBuilder builder, int numElems) { builder.startVector(4, numElems, 4); }
  public static int endNodeModel(FlatBufferBuilder builder) {
    int o = builder.endTable();
    builder.required(o, 4);  // registration_name
    return o;
  }

  public static final class Vector extends BaseVector {
    public Vector __assign(int _vector, int _element_size, ByteBuffer _bb) { __reset(_vector, _element_size, _bb); return this; }

    public NodeModel get(int j) { return get(new NodeModel(), j); }
    public NodeModel get(NodeModel obj, int j) {  return obj.__assign(__indirect(__element(j), bb), bb); }
  }
}

